################################################################################
import numpy as np
import scipy.linalg as spl
import matplotlib.pyplot as plt
################################################################################

def main():
    # Finding the coefficients.
    A = np.array([[1,-2,4,-8],[1,0,0,0],[1,1,1,1],[1,3,9,27]])
    b = np.array([-16,-3,-1,24])
    a = spl.solve(A,b)

    # Plotting the graph.
    x = np.linspace(-3,4,101)
    p = a[3]*x**3+a[2]*x**2+a[1]*x+a[0]
    fig,ax = plt.subplots()
    ax.plot(x,p,color="green",linewidth=2)
    ax.set_xlabel("x")
    ax.set_ylabel("y")
    ax.grid()
    fig.savefig("EX0_Q1.png",dpi=100,facecolor="#f1f1f1")


main()
